            #property     copyright     "Copyright  2016"
            #property     link                  "www.tradingaxis.com"
                    #property     indicator_chart_window
                    #property     indicator_buffers  4

                        #define        HighSide      1
                        #define        LowSide       2

                    extern int
                        ShortPeriod          =       5,
                        LongPeriod           =      60,
                        HighLowMode          =       1, //  0 = hi/lo; 1 = close/open

                        FastMA               =       6,
                        SlowMA               =      12,
                        Crosses              =      50;

                    extern double
                        HighZone             =      80,
                        LowZone              =      20;

            int
                
                BarsToDraw           =   0,                IndicatorShift       =   0,
                HighBar              =   0,                LowBar               =   0,
                ChartLimits          =   0;

            double
                IndicatorOutPut      =   0;

            datetime
                BarTime              =   0;

            double
                ShortPeriodData        [ ],                LongPeriodData         [ ],

                HighsShortPeriod       [ ],                LowsShortPeriod        [ ],
                HighsLongPeriod        [ ],                LowsLongPeriod         [ ];



//
//    CONFIGURATION DIVISION    
void init(){//


                ChartLimits          =   Bars - 2;

        
                IndicatorBuffers( 5 );

                SetIndexBuffer( 0, HighsShortPeriod );
                SetIndexBuffer( 1, LowsShortPeriod  );
                SetIndexBuffer( 2, HighsLongPeriod  );
                SetIndexBuffer( 3, LowsLongPeriod   );

                SetIndexStyle( 0, DRAW_ARROW, EMPTY, 5, Yellow );
                SetIndexStyle( 1, DRAW_ARROW, EMPTY, 5, DodgerBlue );
                SetIndexStyle( 2, DRAW_ARROW, EMPTY, 1, Red );
                SetIndexStyle( 3, DRAW_ARROW, EMPTY, 1, Lime );

                SetIndexArrow( 0, 158 );
                SetIndexArrow( 1, 158 );
                SetIndexArrow( 2, 163 );
                SetIndexArrow( 3, 163 );

                SetIndexEmptyValue( 0, 0.0 );
                SetIndexEmptyValue( 1, 0.0 );
                SetIndexEmptyValue( 2, 0.0 );
                SetIndexEmptyValue( 3, 0.0 );

                SetIndexLabel( 0, " Short Period High " );
                SetIndexLabel( 1, " Short Period Low "  );
                SetIndexLabel( 2, " Long Period High "  );
                SetIndexLabel( 3, " Long Period Low "   );

                CreateCustomBuffer( ShortPeriodData, ChartLimits );
                CreateCustomBuffer( LongPeriodData,  ChartLimits );



return;}//
//    CODING DIVISION    
void start(){//
                int
                    
                    Index                =   0,
                    Loop                 =   0;



                BarsToDraw  =  UpDateGraph( ChartLimits );



// LABEL 400  INDICATOR INDEX CONSTRUCTION: 



    for( Index = BarsToDraw; Index > 0; Index -- ) {

        BarTime          =  Time[ Index ];
        IndicatorShift   =  iBarShift( NULL, ShortPeriod,  BarTime, False );
        IndicatorOutPut  =  iCustom( NULL, ShortPeriod, "Schaff Trend Cycle",
                                     FastMA, SlowMA, Crosses, True, 0, IndicatorShift );

        ShortPeriodData[ Index ]  =  IndicatorOutPut;

        if( ShortPeriodData[ Index ] < HighZone && ShortPeriodData[ Index + 1 ] > HighZone ) {
            HighBar  =  FindBarCount( ShortPeriodData, Index, HighSide, HighLowMode );
            HighsShortPeriod[ HighBar ]  =  High[ HighBar ] + 7 * Point;

        } else if( ShortPeriodData[ Index ] > LowZone && ShortPeriodData[ Index + 1 ] < LowZone ) {
            LowBar  =  FindBarCount( ShortPeriodData, Index, LowSide, HighLowMode );
            LowsShortPeriod[ LowBar ]  =  Low[ LowBar ] - 7 * Point;
ObjectsRedraw(); 

        } // End If, ShortPeriodData:

    } // End For Loop, Index:



    for( Index = BarsToDraw; Index > 0; Index -- ) {

        BarTime          =  Time[ Index ];
        IndicatorShift   =  iBarShift( NULL, LongPeriod, BarTime, False ); // Why +1 ??
        IndicatorOutPut  =  iCustom( NULL, LongPeriod, "Schaff Trend Cycle",
                                     FastMA, SlowMA, Crosses, True, 0, IndicatorShift );

        LongPeriodData[ Index ]  =  IndicatorOutPut;

        if( LongPeriodData[ Index ] < HighZone && LongPeriodData[ Index + 1 ] > HighZone ) {
            HighBar  =  FindBarCount( LongPeriodData, Index, HighSide, HighLowMode );
            HighsLongPeriod[ HighBar ]  =  High[ HighBar ] + 7 * Point;

        } else if( LongPeriodData[ Index ] > LowZone && LongPeriodData[ Index + 1 ] < LowZone ) {
            LowBar  =  FindBarCount( LongPeriodData, Index, LowSide, HighLowMode );
            LowsLongPeriod[ LowBar ]  =  Low[ LowBar ] - 7 * Point;

        } // End If, LongPeriodData:

    } // End For Loop, Index:



return;}//
//    TERMINATION DIVISION     
void deinit(){//



return;}//
//    FUNCTION DEFINITION DIVISION    
//



int

    
    FindBarCount( double& DataArray[], int Count, int Direction, int Mode ) {
            int     Value           =   0;
            int     CloseMode       =   0;
            int     OpenMode        =   0;
            int     Loop            =  Count + 2;

            switch( Direction ) {

                case HighSide:
                    while( DataArray[ Loop ] > HighZone && Loop < Bars - 2 )    { Loop ++; }
                    Loop --;

                    if( Mode == 0 ) {
                        Value  =  iHighest( Symbol(), Period(), MODE_HIGH, Loop - Count, Count );

                    } else if( Mode == 1 ) {
                        CloseMode  =  iHighest( Symbol(), Period(), MODE_CLOSE, Loop - Count, Count );
                        OpenMode   =  iHighest( Symbol(), Period(), MODE_OPEN,  Loop - Count, Count );

                        Value  =  IFn(( Close[ CloseMode ] > Open[ OpenMode ] ), CloseMode, OpenMode );

                    } // End If, Mode:
                    break;

                case LowSide:
                    while( DataArray[ Loop ] < LowZone && Loop < Bars - 2 )    { Loop ++; }
                    Loop --;

                    if( Mode == 0 ) {
                        Value  =   iLowest( Symbol(), Period(), MODE_LOW, Loop - Count, Count );

                    } else if( Mode == 1 ) {
                        CloseMode  =  iLowest( Symbol(), Period(), MODE_CLOSE, Loop - Count, Count );
                        OpenMode   =  iLowest( Symbol(), Period(), MODE_OPEN,  Loop - Count, Count );

                        Value  =  IFn(( Close[ CloseMode ] < Open[ OpenMode ] ), CloseMode, OpenMode );

                    } // End If, Mode:
                    break;

            } // End Switch Case, Direction:

    return( Value );

} // End Function Procedure, FindBarCount:



/*===============================================================================================|\
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     Creates series arrays for temperary storage of indicator values.                ||
||                                                                                               ||
||  Parameters:  BufferName -- Is the array to be redimed as a series array.                     ||
||               BarCount   -- Is the size the array will be redimed too.                        ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
    void
        CreateCustomBuffer( double& BufferName[], int BarCount ) {

            ArrayResize( BufferName,         BarCount );
            ArrayInitialize( BufferName,  EMPTY_VALUE );
            ArraySetAsSeries( BufferName,        True );

        return;
    } // End Routine Procedure, CreateCustomBuffer:



/*===============================================================================================|\
||                                                                                               ||
||  Returns:     Int Number of Bars to calculate indicator.                                      ||
||                                                                                               ||
||  Purpose:     Is to determene were to start and or complete drawing of indicator lines.       ||
||                                                                                               ||
||  Parameters:  ChartLimits  ---  Is the Limit imposed on the history of desired study.         ||
||                                                                                               ||
||  Note:        If an error occures the function will return a minus 1. This is the basic bar   ||
||               count version, also see PreviousBarsDrawn() function.                           ||
||                                                                                               ||
||  Example:     BarCount = UpDateGraph(); will draw the subject indicator with entire History.  ||
||               BarCount = UpDateGraph( 250 ); will only use the latest 250 bars of history.    ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
int
   
    
    UpDateGraph( int ChartLimits = 0 ){
        int   CalculateBars    =    -1;
        int   BarsCompleted    =    IndicatorCounted();

            if( BarsCompleted >= 0 )
                CalculateBars  =  Bars - BarsCompleted -1;
            else
                Print( "An Error Occured In UpDateGraph Function." );

            if( ChartLimits > 0 && CalculateBars > ChartLimits )
                CalculateBars  =  ChartLimits;

    return( CalculateBars );
 } // End Function Procedure, UpDateGraph:



/*===============================================================================================|\
||                                                                                               ||
||  Returns:     If the condition is true it will return the true parameter else the false       ||
||               parameter. In this case (n) the two parameter values must be of double type.    ||
||                                                                                               ||
||  Parameters:  Condition --- The condition to be tested.                                       ||
||               IfTrue    --- The return value on true conditions.                              ||
||               IfFalse   --- The return value on false conditions.                             ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
double
    IFn( bool Condition, double IfTrue, double IfFalse ) {

        if( Condition ) return( IfTrue ); else return( IfFalse );

} 